// vMac 0.x Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - ROM Function Files

#include "sysconfi.h"                   // includes/sysconfig.h
#include "sysdeps.h"
#include "config.h"
#include "ROM.h"
#include "prefs.h"

#include "memory2.h"                    // includes/memory.h

#ifdef _ROM_Debug
#include <stdio.h>
#endif

#include "Unix/universa.h"              // unix/universal.h

UWORD private_ROM [kROM_Size/2];
UWORD *ROM = private_ROM;

int ROM_Init (void)
{
   FILE *ROM_File;
   int  File_Size;
   int i;

   ROM_File = fopen(thePrefs.ROMPath[thePrefs.CurrentROMPath], "rb");
   if (ROM_File == NULL)
      ROM_File = fopen("vMac.ROM","rb");
  
   if (ROM_File == NULL) {    
      fprintf(stderr, "vMac: The vMac.ROM could not be found.\n");
      return 1;
   }
   fprintf(stderr, "vMac: Loading vMac.ROM...\n");
   File_Size = fread(ROM, kROM_Size, 1, ROM_File);
   if (File_Size != 1) {
      fprintf(stderr, "vMac: Sorry, the vMac.ROM is not 128 KB.\n");
      fclose(ROM_File);
      return 1;
   }
   fclose(ROM_File);

   if ((do_get_mem_word(&ROM[0]) == 0x4D1E) && (do_get_mem_word(&ROM[1]) == 0xEEE1)) {
      fprintf(stderr, "vMac: vMac.ROM loaded successfully, Mac Plus ROM v 1, 'Lonely Hearts'.\n");
      return 0;
   }

   if ((do_get_mem_word(&ROM[0]) == 0x4D1E) && (do_get_mem_word(&ROM[1]) == 0xEAE1)) {
      fprintf(stderr, "vMac: vMac.ROM loaded successfully, Mac Plus ROM v 2, 'Lonely Heifers'.\n");
      return 0;
   }

   if ((do_get_mem_word(&ROM[0]) == 0x4D1F) && (do_get_mem_word(&ROM[1]) == 0x8172)) { 
      fprintf(stderr, "vMac: vMac.ROM loaded successfully, Mac Plus ROM v 3, 'Loud Harmonicas'.\n");
      return 0;
   }

   fprintf(stderr, "vMac: vMac.ROM loaded successfully, but we don't support this ROM yet.\n");
   return 1;
}

void ROM_Reset (void)
{
   extern UBYTE Sony_Installed;
  
   if (Sony_Installed == 1)
      (void) ROM_Init();
}

UWORD *ROM_Xlate (CPTR addr)
{
   return ROM + (addr >> 1);
}

UBYTE ROM_GetB (CPTR addr)
{
   return ROM [addr >> 1] >> (addr & 1 ? 0 : 8);
}

UWORD ROM_GetW (CPTR addr)
{
   return ROM [addr >> 1];
}

ULONG ROM_GetL (CPTR addr)
{
   return ((ULONG) ROM [addr >> 1] << 16) | ROM [(addr >> 1) + 1];
}

void ROM_PutB (CPTR addr, UBYTE in)
{ 
   return;
}

void ROM_PutW (CPTR addr, UWORD in)
{
   return;
}

void ROM_PutL (CPTR addr, ULONG in)
{
   return;
}
